#pragma once
#pragma comment(lib,"Wininet.lib")
#include <wininet.h>
//------------------------------------------------------------------------
// RATEڕێ
//
//------------------------------------------------------------------------
class CXRateInfoItem
{
public:
	CXRateInfoItem(void)
	{
		gcurBid = -1L;
	};
	~CXRateInfoItem(void) {};

	CString			gstrName;							// 
	CXCurrency		gcurBid;							// 
	CXCurrency		gcurAsk;							// 
	CString			gstrChange;							// ړ
	CString			gstrBidOpen;						// I[vl
	CString			gstrBidHi;							// l
	CString			gstrBidLow;							// l
	CString			gstrBuySwap;						// Xbv
	CString			gstrSellSwap;						// Xbv
	CString			gstrUnit;							// P

	ASKRATE         gtblAskRate;						// ASKϊ{

	int             gintBidDifference;					// lOƂ̔r(1:オ,0:ς炸,-1:)
	BOOL LoadItem ( CString &strItem , int &curPos )
	{
		int i;
		CString strToken;
		CString  strBid;
		CString  strAsk;
		int      curBidAskPos = 0;
		CXCurrency  curBid;
		int curNewPos = 0;
		for (i = 0 ; i < 9 ; i++ ) {
//			strToken = strItem.Tokenize ( _T("_") , curPos );
			curNewPos = strItem.Find ( '_' , curPos);
			if ( curNewPos >= 0 )
			{
				strToken = strItem.Mid(curPos,curNewPos-curPos);
				curPos=curNewPos+1;
				switch (i) 
				{
				case 0:
					gstrName = strToken;
					break;
				case 1:
					curBidAskPos = 0;
					strBid = strToken.Tokenize(_T("-"), curBidAskPos);
					curBid = CXCurrency(strBid);
					if (gcurBid >= CXCurrency(0L) ) {			//?Ol
						if ( gcurBid < curBid ) {				//?オ
							gintBidDifference = 1;
						}
						else if ( gcurBid > curBid ) {			//?
							gintBidDifference = -1;
						}
						else {									//
							gintBidDifference = 0;
						}
					}
					gcurBid = curBid;

					strAsk  = strToken.Tokenize(_T("-"),curBidAskPos);
					{
						CXCurrency _curW = curBid * gtblAskRate.Rate;
						CXCurrency _curA ( _curW.GetInteger() );
                        _curA.SetFraction ( _ttoi ((LPCTSTR)strAsk)*100 );
						CXCurrency _curB = _curA / gtblAskRate.Rate;
						if ( _curB < curBid )                          //?オ
						{
							_curA += 1L;
						}
						gcurAsk = _curA / gtblAskRate.Rate;

					}
					break;
				case 2:
					gstrChange= strToken;
					break;
				case 3:
					gstrBidOpen = strToken;
					break;
				case 4:
					gstrBidHi = strToken;
					break;
				case 5:
					gstrBidLow = strToken;
					break;
				case 6:                            //
					break;
				case 7:
					gstrBuySwap = strToken;
					break;
				case 8:
					gstrSellSwap = strToken;
					break;
//				case 9:
//					gstrUnit = strToken;
//					break;
				}
			}
		}
	return TRUE;
	}
};
struct ClockTable {
	CString            strName;					// O
	COleDateTimeSpan   clsSpanTime;				// 
	BOOL               blnEnabled;              // \L/
	COleDateTime       clsCurrentTime;
};
typedef CAtlArray<ClockTable>	ArrayClockTable;

class CXRateInfoItems
{
public:
	int gintCount;								// o^

	CXRateInfoItem   gtblItems[RATEITEM_COUNTS];
	CString			 gstrDateTime;
	SYSTEMTIME		 gudtHttpDateTime;						// Httpwb_[DateTime(GMT)
	ArrayClockTable  gtblClock;								// p^(ݎ)
	int              gintClockCaptionMax;                   //p^LvVő咷

	CXRateInfoItems(void)
	{
		gintCount = 0;
		for ( size_t i = 0 ; i < RATEITEM_COUNTS ;i++ )
		{
			gtblItems[i].gtblAskRate = gtblAskRate[i];		// ASKϊe[u
		}
	};
	~CXRateInfoItems(void) {};
	//
	// 
	//
	void SetParameter ( const ArrayClockParameterTable &tblParameterClock ) {
		ClockTable tblClock;

		gtblClock.RemoveAll ();
		gintClockCaptionMax = 0;
		for ( size_t i = 0 ; i < tblParameterClock.GetCount() ;i++ ) {
			if ( tblParameterClock[i].blnEnabled ) {					//?L
				tblClock.strName = tblParameterClock[i].strName;
				if ( tblClock.strName.GetLength() > gintClockCaptionMax ) {
					gintClockCaptionMax = tblClock.strName.GetLength() ;
				}
				tblClock.clsSpanTime = tblParameterClock[i].clsSpanTime;
				tblClock.blnEnabled    = tblParameterClock[i].blnEnabled;
				gtblClock.Add ( tblClock );
			}
		}

	}
	//-----------------------------------------------------------------
	//  vfŜ̃[h
	//-----------------------------------------------------------------
	BOOL LoadItems ( CString &strHttpDateTime , CString &strSource )
	{
		int i;
		int curPos = 0;
		char chCkeckChar;

		gintCount = 0;
		for ( i = 0 ; i < RATEITEM_COUNTS ; i++ ) {
			chCkeckChar = *strSource.Left(1);                                //擪擾
			if ( chCkeckChar >= '0' && chCkeckChar <= '9') {				//?
				break;
			}
			gtblItems[i].LoadItem ( strSource , curPos );
			gintCount++;
		}
		gstrDateTime = strSource.Tokenize ( _T("_") , curPos );               //t
        StringDateTimeToSystemTime ( gstrDateTime ,  &gudtHttpDateTime );
//		::InternetTimeToSystemTime ( (LPCTSTR)strHttpDateTime , &gudtHttpDateTime , 0 );
		for ( size_t intIndex = 0 ; intIndex < gtblClock.GetCount() ; intIndex++ ) {
			gtblClock[intIndex].clsCurrentTime = gudtHttpDateTime;
			gtblClock[intIndex].clsCurrentTime += gtblClock[intIndex].clsSpanTime;
		}
		return TRUE;
	}
	//------------------------------------------------------------------
	// YYYY/MM/DD HH:NN:SS  SystemDateɕϊ
	//------------------------------------------------------------------
	void StringDateTimeToSystemTime ( CString &strDateTime , SYSTEMTIME *pudtSystemTime )
	{
		CString strRes;
		int     lngPos = 0;
		int     lngCount = 0;
		int     intYear=2005;
		int     intMonth=1;
		int     intDay=1;
		int     intHour=0;
		int     intMinute=0;
		int     intSecond=0;

		try {
			strRes = strDateTime.Tokenize ( _T("/ :") , lngPos );
			while  ( strRes != "" && lngCount < 6 ) {
				switch (lngCount) {
				case 0:
					intYear = _ttoi ( strRes );
					break;
				case 1:
					intMonth = _ttoi(strRes);
					break;
				case 2:
					intDay  = _ttoi(strRes);
					break;
				case 3:
					intHour  = _ttoi(strRes);
					break;
				case 4:
					intMinute = _ttoi(strRes);
					break;
				case 5:
					intSecond = _ttoi(strRes);
					break;
				}
				strRes = strDateTime.Tokenize ( _T("/ :") , lngPos );
				lngCount++;
			}
			CTime clsTime (intYear,intMonth,intDay,intHour,intMinute,intSecond);
			clsTime -= CTimeSpan(0,9,0,0);									//JST-->GMTϊ
			clsTime.GetAsSystemTime ( *pudtSystemTime );
		}
		catch ( ... ) {
#if defined(_DEBUG)
			CString strMsg;
			strMsg.Format ( _T("ԕϊG[ =%s") , (LPCTSTR)strDateTime );
			::MessageBox ( NULL , (LPCTSTR)strMsg , _T("O׃:ԕϊG[") , MB_ICONERROR );
#else
			CTime clsTime = CTime::GetCurrentTime();
			clsTime.GetAsSystemTime ( *pudtSystemTime );
#endif
		}
	}
};
